name: Build AppImage
run-name: ${{ gitea.actor }} is building THE AppImage 🚀   # a lot of excitement for this build
on:
  push:
    branches:
      - master

jobs:
  Explore-Gitea-Actions:
    runs-on: bookworm
    steps:
      - name: Check out repository code
        uses: actions/checkout@v3
      - run: |
          apt-get -y update
          apt-get -y install python3-yaml python3-requests
      - name: Declare some variables
        shell: bash
        run: |
          echo "SHA_SHORT=$(git rev-parse --short HEAD)" >> $GITHUB_ENV
          echo "YEAR=$(date +%Y)" >> $GITHUB_ENV
      - name: Build AppImage
        run: |
          echo $GO_PIPELINE_LABEL
          eval $(gpg-agent --daemon --allow-preset-passphrase --default-cache-ttl 1 --max-cache-ttl 7200)
          /usr/lib/gnupg/gpg-preset-passphrase --preset --passphrase ${GPG_PASSPHRASE} ${GPG_KEYGRIP}
          ./tools/update_version.py
          ./tools/build.sh
        env:
          GPG_KEYGRIP: ${{ vars.GPG_KEYGRIP }}
          GPG_PASSPHRASE: ${{ secrets.GPG_PASSPHRASE }}
          GO_PIPELINE_LABEL: ${{ env.YEAR }}.${{ gitea.run_number }}_${{ env.SHA_SHORT }}
      - name: Upload AppImage
        run: ./tools/upload_gitea.sh
        env:
          GO_PIPELINE_LABEL: ${{ env.YEAR }}.${{ gitea.run_number }}_${{ env.SHA_SHORT }}
          UPLOAD_TOKEN: ${{ secrets.UPLOAD_TOKEN }}
          UPLOAD_USER: ${{ vars.UPLOAD_USER }}
